package ast;

import types.Type;

public class Local extends Node implements Stat{
	public Id id;
	public Exp rval;
	
	public Local(Id id, Exp rval, int line, int col) {
		super(line, col);
		this.id = id;
		this.rval = rval;
	}
	
	public String label() {
		return "=";
	}
	
	public void run(Environment<Object> env) {
		if(rval != null)
			env.bind(id.name, rval.eval(env));
		else
			env.bind(id.name, null);
	}

	@Override
	public void tcStat(Environment<Type> tenv) {
		tenv.bind(id.name, rval.tcExp(tenv));
		System.out.println(id.name + ": " + tenv.lookup(id.name).prune());
	}
}
